#include<bits/stdc++.h>
using namespace std;
int N,Q,r,l,pr,z;
long long s,prefiks[200005],niz[200005];
int main() {
    cin>>N>>Q;
    prefiks[0]=0;
    for(int i=1;i<=N;i++) {
        cin>>niz[i];
        prefiks[i]=prefiks[i-1]+niz[i];
    }
    if(N<=1000) {
        for(int i=1;i<=Q;i++) {
            cin>>r>>l;
            s=niz[r];
            for(int j=r+1;j<=l;j++)
                s&=niz[j];
            cout<<s<<endl;
        }
    }

    else {
        for(int i=1;i<=Q;i++) {
            cin>>r>>l;
            pr=prefiks[l]-prefiks[r-1];
            z=l-r+1;
            if(pr==z)
                cout<<1<<endl;
            else
                cout<<0<<endl;
        }
    }
    return 0;
}